#include <Arduino.h>
#include "Timer.h"
#include "WizFi310.h"

#define PERIOD (5 * 1000)

#define SWITCH 8
#define MASK_ON 11

#define TOKEN     "pfOw4nhL05Or33sfXGpsvfb646DxC4"
#define VARID_LED_MASK   "5c40129fc03f9732919dcdbe"
#define VALUE "{\"value\": 1}"

WiFiClient client;
Timer timer_t;
uint8_t timeout_timer_id;
uint8_t current_val = 0, prev_val = 0;

IPAddress targetIP(50, 23, 124, 68);

//char  ssid[] = "wizms1";         //your network SSID
//char  pass[] = "maker0701";        //your network password

char  ssid[] = "DIR-815_Wiznet";         //your network SSID
char  pass[] = "wiznet1206";        //your network password
int   status = WL_IDLE_STATUS;    //the WiFi radio's status
char cmd[1024];

void send_timer_handler (void)
{
  Serial.print("send_timer_handler");
  digitalWrite(MASK_ON, LOW);

  if (client.connect(targetIP, 80)) {
    Serial.println("Connected to server");
    client.println(cmd);
  }
  client.flush();
  client.stop();
}

void on_handler (void)
{
  Serial.print("on_handler");
  digitalWrite(MASK_ON, HIGH);
  timer_t.stop(timeout_timer_id);
  timeout_timer_id = timer_t.after(PERIOD, send_timer_handler);
}

void setup() {
  Serial.begin(115200);
  Serial3.begin(115200);
  delay(6000);
  Serial.print("Starting...");
  Serial.println("WiFi initiallize"); 
  WiFi.init(&Serial3);
  uint8_t value_len = strlen((char *)VALUE);
  
  if(WiFi.status() == 0)
  {
    Serial.println("Failed to configure WiFi");
    while(true);
  }

  while(status !=WL_CONNECTED)
  {
    Serial.print("[WiFi] Attempting to connect to WPA SSID: ");
    Serial.println(ssid);
    //Connect to WPA/WPA2 network
//  Serial.print(pass);
    status = WiFi.begin(ssid, pass);
//    Serial.println(status);
    delay(3000);
  }
  delay(1000);
  
  pinMode(SWITCH, INPUT_PULLUP);
  pinMode(MASK_ON, OUTPUT);
  pinMode(12, OUTPUT);
  digitalWrite(MASK_ON, LOW);
  digitalWrite(12, HIGH);

  sprintf(cmd,"POST /api/v1.6/variables/%s/values HTTP/1.1\r\nContent-Type: application/json\r\nContent-Length: %d\r\nX-Auth-Token: %s\r\nHost: things.ubidots.com\r\n\r\n%s\r\n\r\n", VARID_LED_MASK, value_len, TOKEN, VALUE);
  Serial.println(cmd);
  Serial.println("finished setup");
}

void loop() {
  timer_t.update();
  if ((digitalRead(SWITCH)) == 0)
  {
    current_val = 1;
    if (current_val != prev_val)
    {
      prev_val = current_val;
      digitalWrite(MASK_ON, HIGH);
      timer_t.stop(timeout_timer_id);
      timeout_timer_id = timer_t.after(PERIOD, send_timer_handler);
    }
  }
  else
  {    
    digitalWrite(MASK_ON, LOW);
    timer_t.stop(timeout_timer_id);
    prev_val = current_val;
    current_val = 0;
  }
}

